# MPI_Comm_set_attr

Stores attribute value associated with a key

## Synopsis

    int MPI_Comm_set_attr(MPI_Comm comm, int comm_keyval, void *attribute_val)

## Input Parameters

comm
  communicator to which attribute will be attached (handle)
keyval
  key value, as returned by `MPI_Comm_create_keyval` (integer)
attribute_val
  attribute value

## Notes

Values of the permanent attributes `MPI_TAG_UB`, `MPI_HOST`, `MPI_IO`, `MPI_WTIME_IS_GLOBAL`, `MPI_UNIVERSE_SIZE`, `MPI_LASTUSEDCODE`, and `MPI_APPNUM` may not be changed.

The type of the attribute value depends on whether C, C++, or Fortran is being used. In C and C++, an attribute value is a pointer (`void *`); in Fortran, it is an address-sized integer.

If an attribute is already present, the delete function (specified when the corresponding keyval was created) will be called.

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_COMM
  Invalid communicator. A common error is to use a null communicator in a call (not even allowed in `MPI_Comm_rank`).

MPI_ERR_KEYVAL
  Invalid keyval

MPI_ERR_ARG
  This error class is associated with an error code that indicates that an attempt was made to free one of the permanent keys.

## See Also

MPI_Comm_create_keyval, MPI_Comm_delete_attr

Location:comm_set_attr.c